searchNodes=[{"doc":"Help Elixir applications more easily take advantage of distributed Elixir applications using Ecto and PostgreSQL in a primary/replica configuration on Fly.io.","ref":"Fly.Postgres.html","title":"Fly.Postgres","type":"module"},{"doc":"Compute the database url to use for this app given the current configuration and runtime environment.","ref":"Fly.Postgres.html#database_url/0","title":"Fly.Postgres.database_url/0","type":"function"},{"doc":"Returns the Repo module used by the application that is not the wrapped version. Used for making direct writable calls. Example Requires using application to configure. # Configure database repository config :fly_postgres , :local_repo , MyApp.Repo.Local","ref":"Fly.Postgres.html#local_repo/0","title":"Fly.Postgres.local_repo/0","type":"function"},{"doc":"Function used to make the repository be read-only and error when creates, updates, or deletes are attempted. This behaves like a read-only replica which is helpful when modelling that setup locally in a dev environment. Example In your config/dev.exs , # Configure your database config :my_app , MyApp.Repo.Local , username : &quot;postgres&quot; , password : &quot;postgres&quot; , database : &quot;my_db_dev&quot; , hostname : &quot;localhost&quot; , show_sensitive_data_on_connection_error : true , # Forcing the repo to be R/O locally for dev testing after_connect : { Fly , :make_connection_read_only! , [ ] } , pool_size : 10","ref":"Fly.Postgres.html#make_connection_read_only!/1","title":"Fly.Postgres.make_connection_read_only!/1","type":"function"},{"doc":"Return the database url used for connecting to the primary database. This is provided by the Fly.io platform when you have attached to a PostgreSQL database. Stored as an ENV called DATABASE_URL .","ref":"Fly.Postgres.html#primary_db_url/0","title":"Fly.Postgres.primary_db_url/0","type":"function"},{"doc":"Return a database url used for connecting to a replica database. This makes the assumption that there is a replica running in the region where the app instance is running.","ref":"Fly.Postgres.html#replica_db_url/0","title":"Fly.Postgres.replica_db_url/0","type":"function"},{"doc":"Execute the MFA (Module, Function, Arguments) on a node in the primary region. This presumes the primary region has direct access to a writable primary Postgres database. This waits for the data to be replicated to the current node before continuing on.","ref":"Fly.Postgres.html#rpc_and_wait/4","title":"Fly.Postgres.rpc_and_wait/4","type":"function"},{"doc":"Data structure that represents a PostgreSQL LSN or Log Sequence Number. Two LSN values can be compared using the replicated?/2 function. An LSN associated with the DB modification has a source of :insert . On a replica instance, that can be used to see when the insert has been replicated locally.","ref":"Fly.Postgres.LSN.html","title":"Fly.Postgres.LSN","type":"module"},{"doc":"After performing a database modification, calling current_wal_insert/1 returns a value that can be used to compare against a WAL value from the replica database to determine when the changes have been replayed on the replica.","ref":"Fly.Postgres.LSN.html#current_wal_insert/1","title":"Fly.Postgres.LSN.current_wal_insert/1","type":"function"},{"doc":"When talking to a replica database, this returns a value for what changes have been replayed on the replica from the primary.","ref":"Fly.Postgres.LSN.html#last_wal_replay/1","title":"Fly.Postgres.LSN.last_wal_replay/1","type":"function"},{"doc":"Create a new Fly.Postgres.LSN struct from the a queried WAL value.","ref":"Fly.Postgres.LSN.html#new/2","title":"Fly.Postgres.LSN.new/2","type":"function"},{"doc":"Compare two Fly.Postgres.LSN structs to determine if the transaction representing a data change on the primary has been replayed locally. They are compared where the replay/replica value is in argument 1 and the insert value is in arguemnt two. Examples repo |&gt; last_wal_replay ( ) |&gt; replicated? ( primary_lsn )","ref":"Fly.Postgres.LSN.html#replicated?/2","title":"Fly.Postgres.LSN.replicated?/2","type":"function"},{"doc":"","ref":"Fly.Postgres.LSN.html#t:t/0","title":"Fly.Postgres.LSN.t/0","type":"type"},{"doc":"Track the current PostgreSQL LSN or Log Sequence Number. This is used to determine which portions of the database log have been replicated locally. This lets us determine if a specific transaction chunk has been replicated to know that some expected data is present. The client process doesn't interact directly with the Tracker GenServer. The client can request_notification or request_and_await_notification and the Tracker will notify the process when the data replication has been seen.","ref":"Fly.Postgres.LSN.Tracker.html","title":"Fly.Postgres.LSN.Tracker","type":"module"},{"doc":"Blocking function that waits for a request_notification/2 response message to be received. The timeout defaults to 3s after which time it stops waiting and returns an {:error, :timeout} response.","ref":"Fly.Postgres.LSN.Tracker.html#await_notification/2","title":"Fly.Postgres.LSN.Tracker.await_notification/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Fly.Postgres.LSN.Tracker.html#child_spec/1","title":"Fly.Postgres.LSN.Tracker.child_spec/1","type":"function"},{"doc":"Get the latest cached LSN replay value.","ref":"Fly.Postgres.LSN.Tracker.html#get_last_replay/1","title":"Fly.Postgres.LSN.Tracker.get_last_replay/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Fly.Postgres.LSN.Tracker.html#init/1","title":"Fly.Postgres.LSN.Tracker.init/1","type":"function"},{"doc":"Return if the LSN value was replicated.","ref":"Fly.Postgres.LSN.Tracker.html#replicated?/2","title":"Fly.Postgres.LSN.Tracker.replicated?/2","type":"function"},{"doc":"Request to be notified when the desired level of data replication has completed and wait for it to complete. Optionally it may timeout if it takes too long.","ref":"Fly.Postgres.LSN.Tracker.html#request_and_await_notification/2","title":"Fly.Postgres.LSN.Tracker.request_and_await_notification/2","type":"function"},{"doc":"Request notification for when the database replication includes the LSN the process cares about. This allows a process to block and await their data to be replicated and be notified as soon as it's detected.","ref":"Fly.Postgres.LSN.Tracker.html#request_notification/2","title":"Fly.Postgres.LSN.Tracker.request_notification/2","type":"function"},{"doc":"Start the Tracker that receives work requests.","ref":"Fly.Postgres.LSN.Tracker.html#start_link/1","title":"Fly.Postgres.LSN.Tracker.start_link/1","type":"function"},{"doc":"This wraps the built-in Ecto.Repo functions to proxy writable functions like insert, update and delete to be performed on the an Elixir node in the primary region. To use it, rename your existing repo module and add a new module with the same name as your original repo like this. Original code: defmodule MyApp.Repo do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.Postgres end Changes to: defmodule MyApp.Repo.Local do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.Postgres # Dynamically configure the database url based for runtime environment. def init ( _type , config ) do { :ok , Keyword . put ( config , :url , Fly.Postgres . database_url ( ) ) } end end defmodule Core.Repo do use Fly.Repo , local_repo : MyApp.Repo.Local end Using the same name allows your existing code to seamlessly work with the new repo. When explicitly managing database transactions like using Multi or start_transaction , when used to modify data, those functions should be called by an RPC so they run in the primary region. Fly.RPC . rpc_region ( :primary , MyModule , :my_function_that_uses_multi , [ my , args ] , opts )","ref":"Fly.Repo.html","title":"Fly.Repo","type":"module"},{"doc":"Fly Postgres Helps take advantage of geographically distributed Elixir applications using Ecto and PostgreSQL in a primary/replica configuration on Fly.io . Online Documentation","ref":"readme.html","title":"Fly Postgres","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding fly_postgres to your list of dependencies in mix.exs : def deps do [ { :fly_postgres , &quot;~&gt; 0.1.0&quot; } ] end Note that fly_postgres depends on fly_rpc so it will be pulled in as well. The configuration section below includes the relevant parts for fly_rpc .","ref":"readme.html#installation","title":"Fly Postgres - Installation","type":"extras"},{"doc":"Repo This assumes your project already has an Ecto.Repo . To start using the Fly.Repo , here are the changes to make. For a project named &quot;MyApp&quot;, change it from this... defmodule MyApp.Repo do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.Postgres end To something like this... defmodule MyApp.Repo.Local do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.Postgres # Dynamically configure the database url based on runtime environment. def init ( _type , config ) do { :ok , Keyword . put ( config , :url , Fly.Postgres . database_url ( ) ) } end end defmodule MyApp.Repo do use Fly.Repo , local_repo : MyApp.Repo.Local end This renames your existing repo to &quot;move it out of the way&quot; and adds a new repo to the same file. The new repo uses the Fly.Repo and links back to your project's Ecto.Repo . The new repo has the same name as your original Ecto.Repo , so your application will be referring to it now when talking to the database. The other change was to add the init function to your Ecto.Repo . This dynamically configures your Ecto.Repo to connect to the primary (writable) database when your application is running in the primary region. When your application is not in the primary region, it is configured to connect to the local read-only replica. The replica is like a fast local cache of all your data. This means you Ecto.Repo is configured to talk to it's &quot;local&quot; database. The Fly.Repo performs all read operations like all , one , and get_by directly on the local replica. Other modifying functions like insert , update , and delete are performed on the primary database through proxy calls to a node in your Elixir cluster running in the primary region. That ability is provided by the fly_rpc library. Config Files In your config/config.exs , add something like the following: # Configure database repository config :fly_postgres , :local_repo , MyApp.Repo.Local This helps the library to know which repo to use when talking to the database to ensure the needed replications have completed. Repo References The goal with using this repo wrapper, is to leave all of your application code and business logic unchanged. However, there are a few places that need to be updated to make it work smoothly. The following examples are places in your project code that need reference your actual Ecto.Repo . Following the above example, it should point to MyApp.Repo.Local . test_helper.exs files make references like this Ecto.Adapters.SQL.Sandbox.mode(MyApp.Repo.Local, :manual) data_case.exs files start the repo using Ecto.Adapters.SQL.Sandbox.start_owner! calls. channel_case.exs need to start your local repo. conn_case.exs need to start your local repo. config/config.exs needs to identify your local repo module. Ex: ecto_repos: [MyApp.Repo.Local] config/dev.exs , config/test.exs , config/runtime.exs - any special repo configuration should refer to your local repo. With these project plumbing changes, you application code can stay largely untouched! Primary Region If your application is deployed to multiple Fly.io regions, the instances (or nodes) must be clustered together. Through ENV configuration, you can to tell the app which region is the &quot;primary&quot; region. fly.toml This example configuration says that the Sydney Australia region is the &quot;primary&quot; region. This is where the primary postgres database is created and where our application has fast write access to it. [env] PRIMARY_REGION = &quot;syd&quot; Application There are two entries to add to your application supervision tree. defmodule MyApp.Application do use Application def start ( _type , _args ) do # ... children = [ # Start the RPC server { Fly.RPC , [ ] } , # Start the Ecto repository MyApp.Repo.Local , # Start the tracker after your DB. { Fly.Postgres.LSN.Tracker , [ ] } , #... ] # ... end end The following changes were made: Added the Fly.RPC GenServer Start your Repo Added Fly.Postgres.LSN.Tracker","ref":"readme.html#configuration","title":"Fly Postgres - Configuration","type":"extras"},{"doc":"Automatic Usage Normal calls like MyApp.Repo.all(User) are performed on the local replica repo. They are unchanged and work exactly as you'd expect. Calls that modify the database like &quot;insert, update, and delete&quot;, are performed through an RPC (Remote Procedure Call) in your application running in the primary region. In order for this to work, your application must be clustered together and configured to identify which region is the &quot;primary&quot; region. Additionally, your application needs to be deployed to multiple regions. There must be a deployment in the primary region as well. A call to MyApp.Repo.insert(changeset) will be proxied to perform the insert in the primary region. If the function is already running in the primary region, it just executes normally locally. If the function is running in a non-primary region, it makes a RPC execution to run on the primary. Additionally, it gets the Postgres LSN (Log Sequence Number) for the database after making the change. The calling function then blocks, waits for the async database replication process to complete, and continues on once the data modification has replayed on the local replica. In this way, it becomes seamless for you and your code! You get the benefits of being globally distributed and running closer to your users without re-designing your application! Explicit Usage","ref":"readme.html#usage","title":"Fly Postgres - Usage","type":"extras"}]